#include "mgos.h"
#include "mgos_app.h"
#include "mgos_sys_config.h"
#include "mgos_timers.h"

#include "buttonHandler.h"
#include "ledHandler.h"
#include "relayHandler.h"
#include "mqttHandler.h"

static void buttonPressOne(int pressCount) {
    LOG(LL_DEBUG, ("buttonPressOne called with pressCount=%d", pressCount));
    set_relay(RELAY_TOGGLE);
}

static void buttonPressTwo(int pressCount) {
    LOG(LL_DEBUG, ("buttonPressTwo called with pressCount=%d", pressCount));
}

static void buttonPressThree(int pressCount) {
    LOG(LL_DEBUG, ("buttonPressThree called with pressCount=%d", pressCount));
}

enum mgos_app_init_result mgos_app_init(void) {
    init_led_handler();
    set_led_status(LED_BLINK_FAST);
    init_button_handler();
    add_button_press_callback(1, buttonPressOne);
    add_button_press_callback(2, buttonPressTwo);
    add_button_press_callback(3, buttonPressThree);
    init_mqtt_handler();
    LOG(LL_INFO, ("SONOFF app initialized"));
    return MGOS_APP_INIT_SUCCESS;
}
